<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for actions StructType
 * @subpackage Structs
 */
class Actions extends AbstractStructBase
{
    /**
     * The submit
     * @var bool
     */
    public $submit;
    /**
     * Constructor method for actions
     * @uses Actions::setSubmit()
     * @param bool $submit
     */
    public function __construct($submit = null)
    {
        $this
            ->setSubmit($submit);
    }
    /**
     * Get submit value
     * @return bool|null
     */
    public function getSubmit()
    {
        return $this->submit;
    }
    /**
     * Set submit value
     * @param bool $submit
     * @return \StructType\Actions
     */
    public function setSubmit($submit = null)
    {
        // validation for constraint: boolean
        if (!is_null($submit) && !is_bool($submit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($submit, true), gettype($submit)), __LINE__);
        }
        $this->submit = $submit;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Actions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
