<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for contractListRequest StructType
 * @subpackage Structs
 */
class ContractListRequest extends AbstractStructBase
{
    /**
     * The requestToken
     * @var \StructType\RequestToken
     */
    public $requestToken;
    /**
     * The createDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CreateDate
     */
    public $createDate;
    /**
     * The signDueDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SignDueDate
     */
    public $signDueDate;
    /**
     * Constructor method for contractListRequest
     * @uses ContractListRequest::setRequestToken()
     * @uses ContractListRequest::setCreateDate()
     * @uses ContractListRequest::setSignDueDate()
     * @param \StructType\RequestToken $requestToken
     * @param \StructType\CreateDate $createDate
     * @param \StructType\SignDueDate $signDueDate
     */
    public function __construct(\StructType\RequestToken $requestToken = null, \StructType\CreateDate $createDate = null, \StructType\SignDueDate $signDueDate = null)
    {
        $this
            ->setRequestToken($requestToken)
            ->setCreateDate($createDate)
            ->setSignDueDate($signDueDate);
    }
    /**
     * Get requestToken value
     * @return \StructType\RequestToken|null
     */
    public function getRequestToken()
    {
        return $this->requestToken;
    }
    /**
     * Set requestToken value
     * @param \StructType\RequestToken $requestToken
     * @return \StructType\ContractListRequest
     */
    public function setRequestToken(\StructType\RequestToken $requestToken = null)
    {
        $this->requestToken = $requestToken;
        return $this;
    }
    /**
     * Get createDate value
     * @return \StructType\CreateDate|null
     */
    public function getCreateDate()
    {
        return $this->createDate;
    }
    /**
     * Set createDate value
     * @param \StructType\CreateDate $createDate
     * @return \StructType\ContractListRequest
     */
    public function setCreateDate(\StructType\CreateDate $createDate = null)
    {
        $this->createDate = $createDate;
        return $this;
    }
    /**
     * Get signDueDate value
     * @return \StructType\SignDueDate|null
     */
    public function getSignDueDate()
    {
        return $this->signDueDate;
    }
    /**
     * Set signDueDate value
     * @param \StructType\SignDueDate $signDueDate
     * @return \StructType\ContractListRequest
     */
    public function setSignDueDate(\StructType\SignDueDate $signDueDate = null)
    {
        $this->signDueDate = $signDueDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContractListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
